<template>
  <div v-click-outside="closeModal">
    <div class="qr-wrapper">
      <div class="qr-content">
        <div class="close-btn" @click="closeModal"></div>

        <qrcode ref="qrcode" :value="modalData.address" :options="{ size: 160 }"></qrcode>
        <p class="title">{{ $t('common.modal.qr.title', {currency: modalData.title.toUpperCase()}) }}</p>
        <p class="address">{{ modalData.address }}</p>

        <div class="group-btn">
          <p class="show-qr-btn" @click="saveQrCode">
            <span class="iconmo-QRcode"></span>
            <span class="btn__text">{{ $t('common.modal.qr.btn_save') }}</span>
            <a ref="qrCodeUrl"></a>
          </p>

          <button
            class="copy-btn"
            v-clipboard:copy="modalData.address"
            v-tooltip="{ content: 'Copied', trigger: 'focus', autoHide: true, delay: { hide:1000 } }">
            <span class="iconmo-copy"></span>
            <span class="btn__text">{{ $t('common.modal.qr.btn_copy') }}</span>
          </button>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
  export default {
    props: {
      modalData: {
        type: Object,
      }
    },
    methods: {
      closeModal() {
        this.$broadcast('close-modal', this);
      },
      saveQrCode() {
        if (!this.$refs.qrcode || !this.$refs.qrcode.$el) {
          return;
        }
        this.$refs.qrCodeUrl.setAttribute('download', `${this.modalData.address}.png`);
        this.$refs.qrCodeUrl.setAttribute('href', this.$refs.qrcode.$el.toDataURL('image/png').replace('image/png', 'image/octet-stream'));
        this.$refs.qrCodeUrl.click();
      }
    },
  };
</script>

<style scoped lang="scss">
  @import '../../../../sass/_variables.scss';
  .show-qr-btn,
  .copy-btn {
    cursor: pointer;
    display: inline-block;
    border-radius: 30px;
    padding: 0 24px;
    margin-right: 10px;
    border: solid 1px #da6400;
    transition: all 0.3s ease-in-out;

    .iconmo-copy,
    .iconmo-QRcode {
      vertical-align: middle;
    }

    .btn__text {
      font-size: $tiny;
      margin-left: 5px;
      vertical-align: middle;
      text-transform: uppercase;
      font-weight: bold;
      line-height: 2.5;
      letter-spacing: 0.5px;
      color: #fa7300;
    }

    &:hover {
      background-color: #fa7300;
      .iconmo-QRcode:before,
      .btn__text {
        color: #fff;
      }
    }
  }

  .copy-btn {
    position: relative;
    padding: 1px 21px 1px 16px;
    background-color: #fa7300;
    border: none;

    &:after {
      content: '';
      display: block;
      position: absolute;
      top: 0;
      left: 0;
      border-radius: 30px;
      width: 100%;
      height: 100%;
      background-color: rgba(#000, 0.3);
      transition: all 0.3s ease-in-out;
      z-index: -1;
    }

    .btn__text {
      color: #fff;
    }

    &:hover {
      &:after {
      z-index: 1;
      }
    }
  }

  .iconmo-QRcode {
    font-size: 16px;

    &:before {
      content: "\e901";
      color: #fa7300;
    }
  }

  .iconmo-copy {
    font-size: 16px;

    &:before {
      content: "\e900";
      color: #fff;
    }
  }

  .qr-content {
    width: 450px;
    height: 450px;
    background-color: #f7f7f7;
    box-shadow: 0 2px 25px 0 rgba(0, 0, 0, 0.12);
    text-align: center;
    padding-top: 80px;
    position: fixed;
    top: 50%;
    border-radius: 10px;
    left: 50%;
    transform: translate(-50%, -50%);

    .title {
      font-size: $small;
      color: #989898;
      margin-bottom: 5px;
      margin-top: 10px;
    }

    .address {
      font-size: $medium;
      font-weight: bold;
      color: $black;
      margin-bottom: 30px;
    }
  }


  .close-btn {
    display: block;
    background-color: #fff;
    border-radius: 50%;
    width: 30px;
    height: 30px;
    position: relative;
    position: absolute;
    right: 15px;
    top: 15px;
    cursor: pointer;

    &:before,
    &:after {
      content: '';
      display: block;
      height: 1px;
      width: 13px;
      position: absolute;
      background-color: #989898;
      left: 50%;
      top: 50%;
      transform: translate(-50%, -50%) rotateZ(45deg);
    }

    &:after {
      transform: translate(-50%, -50%) rotateZ(135deg);
    }
  }
</style>
